/*
    file: mGFlToNFA.cpp
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>



 *
 * Fl to NFA
 *
 *
 */

void mGFlToNFA(const mGLanguage& lang, mGNFA& nfa)

{
	mGSet<mGString> words;
	int i, j, k; //variables to control loops.

	int next_state = 0;
	mGTransition tmpinst;
	mGState start;
	mGState curr;
	mGState next;
	mGArray<mGTransition> t;
//

	nfa.clear();
	words = lang;

	// if no words, empty machine
	if (words.size() == 0)
		return;

	// add one start state
	start = next_state++;
	(nfa.getStartStates()) += start;


	for (i = 0; i < words.size(); ++i)
	{
		curr = start;
		for (j = 0; j < words[i].size(); ++j)
		{
			for (k = 0; k < t.size(); ++k)
				if ((t[k].getStart() == curr)
						&& (t[k].getLabel() == words[i][j]))
					break;
			if (k == t.size()) // if existing arc not found
			{
				// at this point, it is faster if we
				// bypass the rest of the loop
				// and just add transitions manually
				for (; j < words[i].size(); j++)
				{
					next = next_state++;
					t += tmpinst.assign(curr, words[i][j], next);
					curr = next;
				}
				break; // shouldn't need, but just in case
			}
			else
				curr = t[k].getEnd();
		}
		nfa.getFinalStates() += curr;
	}
	t.unique_array();
	nfa.getTransitions() = t;
}
