/*
    file: mGNFAComp.cpp 
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>


 *
 * complete the nfa
 *
 *
 */
void mGNFAComp(mGNFA& nfa)
{
	mGSet<mGState> states;
	mGSet<int> labels;
	nfa.gatherStates(states);
	nfa.gatherLabels(labels);

	//states should already sorted after gathered
	states.quickSortWithSort();
	labels.quickSortWithSort();

	int new_state = states[states.size() - 1].getNumber() + 1;

	mGState newState(new_state);
	states.disjoint_union(newState);
	states.setSorted(true);
	//now we declare an array and set all to a new state
	int to_s[states.size() * labels.size()];

	for (int a = 0; a < states.size() * labels.size(); a++)
	{

		to_s[a] = new_state;

	}

	//now overrides with the actual nfa

	for (int a = 0; a < nfa.getTransitionSize(); a++)
	{

		to_s[states.member(nfa[a].getStart()) * labels.size()+labels.member(nfa[a].getLabel())] =
				nfa[a].getEnd().getNumber();

	}

	//write back
	nfa.clearTransitions();

	for (int a = 0; a < states.size() * labels.size(); a++)
	{
		mGTransition temp(states[(a / labels.size())].getNumber(),
				labels[a % labels.size()], to_s[a]);
		nfa.addTransition(temp);
	}

}
