/*
    file: mGMap.h 
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>


 This implements container map
*/

//for now  just a wrapper of std::map
#ifndef _MGMAP
#include <map>

using namespace std;

template<class Key, class T>
class mGMap
{
protected:
	map<Key, T> m;

public:
	typedef typename std::map<Key, T>::iterator mGMapItator;

//constructors
	/*
	 let c++ do it
	 */

//iterators
	inline mGMapItator begin()
	{
		return m.begin();
	}
	/*
	 inline const_iterator begin() const
	 {
	 return m.begin();
	 }
	 */

	inline mGMapItator end()
	{
		return m.end();
	}
	/*
	 inline const_iterator end() const;
	 {
	 return m.end();
	 }
	 */

	inline T& operator[](const Key& k)
	{
		return m[k];
	}

	inline const T& operator[](const Key& k) const
	{
		return m[k];
	}

	inline int count(const Key& k) const
	{
		return m.count(k);
	}

	inline mGMapItator find(const Key& k) const
	{
		return m.find(k);
	}
	inline int size()
	{
		return m.size();
	}
	inline void clear()
	{
		m.clear();
	}

	mGMap<Key, T>& erase(const Key&);

};
#define _MGMAP
#endif
