/*
    file: mGSet.h 
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>

 This class ,mGSet , implements a classical set
 It is basically an  mGArray, except that there no identical elements are allowed
*/

#ifndef _MGSET

template<class T>

class mGSet: public mGArray<T>
{

//Override methods:

public:

//default constructor and de-constructor is the same in mGArray
//mGSet(const  mGSet& a) is also taken care by mGArray  ?

//		"NO"

//  because compiler will not generate the default constructors and destructors 
//  when we have an user defined copy constructor 
//  compiler does not really search base class as it it generic programmed
//  with only implicit interface
//

//constructor
	mGSet()
	{
		this->sorted = true;
	}

	mGSet(const mGSet<T>& s) :
			mGArray<T>(s)
	{
	} // just use the array's copy
	~mGSet()
	{
	}

//copy from a array
	mGSet(const mGArray<T>&); //TODO: need check duplicated elements?

//assign
	mGSet<T>& operator=(const mGArray<T>&);

//add to end
	mGSet<T>& operator+=(const T&);
	mGSet<T>& operator+=(const mGSet<T>&);

//add directly without checking duplicated
	mGSet<T>& disjoint_union(const T&);
	mGSet<T>& disjoint_union(const mGSet<T>&);

//intersect of two sets
	mGSet<T>& intersect(mGSet<T>&, mGSet<T>&);

};
#define _MGSET
#endif
