/*
    file: fmenum.cpp 
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>

*/

void fmenum()
{

	mGNFA nfa;
	int leng = numeric_limits<int>::max();

	int num = 100;

	//handle -n number
	if (args.size() >= 2)
	{
		if (args.member("-n") >= 0)
		{
			num = atoi(args[args.member("-n") + 1].c_str());
			args -= args[args.member("-n") + 1];
			args -= "-n";
		}

	}

	//if get data from file
	if (args.size() > 0)
	{
		fstream fio;
		fio.open(args[0].c_str(), ios::in);
		if (!fio)
		{
			cerr << CantOpenMsg << args[0] << "\n";
			exit(1);
		};
		fio >> nfa;
		fio.close();
	}
	else
	{
		cin >> nfa;
	}

	mGArray<mGString> arr;

	mGNFAEnum(nfa, arr, num, leng);

	//std::cout << "done!" << std::endl;
	for (int a = 0; a < arr.size(); a++)
	{
		if (a < num)
			std::cout << arr[a] << std::endl;

	}

}
