/*
    file: fmmin_tbf.cpp 
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>

*/

void fmmin_tbf()
{

	mGDFA dfa;

	//if get data from file
	if (args.size() > 0)
	{
		fstream fio;
		fio.open(args[0].c_str(), ios::in);
		if (!fio)
		{
			cerr << CantOpenMsg << args[0] << "\n";
			exit(1);
		};
		fio >> dfa;
		fio.close();
	}
	else
	{
		cin >> dfa;
	}

	//if this a real dfa?
	if (!mGIsDeterm(dfa))
	{
		cout << "Not a dfa!" << endl;
		exit(1);

	}

	//debug?
	if (specific_debug)
	{
		DEBUG_TRIGGER(DEBUG_mGDFAMinimize_TBF);
		cout << "(mGDFAMinimize_TBF debug info will be presented !)" << endl;
	}
	//invoke the table filling algorithm
	mGDFAMinimize_TBF(dfa);

	cout << dfa;

}
