/*
    file: fmunion.cpp 
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>

*/

void fmunion()
{
	mGNFA nfa;
	mGNFA nfa1, nfa2;
	bool check_unique = false;

	//handle -unique number

	if (args.member("-unique") >= 0)
	{
		check_unique = true;

		args -= "-unique";

	}

	//if get data from file: nfa1
	if (args.size() > 0)
	{
		fstream fio;
		fio.open(args[0].c_str(), ios::in);
		if (!fio)
		{
			cerr << CantOpenMsg << args[0] << "\n";
			exit(1);
		};
		fio >> nfa1;
		fio.close();
		args -= args[0];

	}
	else
	{
		cin >> nfa1;
	}

	cin.clear(); //refresh the ctrl-d
	//if get data from file :nfa2
	if (args.size() > 0)
	{
		fstream fio;
		fio.open(args[0].c_str(), ios::in);
		if (!fio)
		{
			cerr << CantOpenMsg << args[0] << "\n";
			exit(1);
		};
		fio >> nfa2;
		fio.close();
	}
	else
	{
		cin >> nfa2;
	}

	mGNFAUnion(nfa1, nfa2, nfa, check_unique);
	cout << nfa;

}
