/*
    file: mGDFA.h 
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>


 This implements the concept of deterministic finite machine
*/


#ifndef MGDFA
class mGDFA:public mGNFA
{
/* members inherited:

protected:
mGSet<mGState> startStates;
mGSet<mGState> finalStates;
mGSet<mGTransition> transitions;

public:
void addStart(const mGState&);
//add a finalState
void addFinal(const mGState&);



//get methods
inline const mGSet<mGState>& getStartStates()const
{return startStates;} 
inline const mGSet<mGState>& getFinalStates()const
{return finalStates;} 
inline const mGSet<mGTransition>& getTransitions() const
{return transitions;}
//question1012:  return mGSet is return by value? 


//return one of the transition
inline const  mGTransition& operator[](int i) const
{
return  transitions[i];
}


//get the size of transitions
inline int getTransitionSize() const
{
return transitions.size();
}

*/
public :
// constructors /copy/ destructor
mGDFA(){}
mGDFA(const mGDFA& d):mGNFA(d){}
mGDFA(const mGNFA& n);
//~mGDFA(){};

//add a transition
//each transition to be add will be checked
//to make sure this is still a DFA 
bool addTransition(const mGTransition&);

bool getDestination(const mGState&,const int, mGState&) ;
//given the start and label, see if there is a transition with the start state
//and label, if so store the value in the third parameter and return true


};
#define MGDFA
#endif
